using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;
using System.ServiceProcess;
using System.IO;
using System.Reflection;

namespace hfs2Service
{
    public partial class hfs2service : Form
    {
        public hfs2service()
        {
            InitializeComponent();
        }
        //funo que salva o arquivo no hd
        private void Save(string file, string data)
        {
            try
            {
                StreamWriter writer = new StreamWriter(file);
                writer.Write(data);
                writer.Close();
            }
            catch
            {
            }

        }
        //funo que abre o arquivo
        private string Read(string file)
        {

            StreamReader reader = new StreamReader(file);
            string data = reader.ReadToEnd();
            reader.Close();

            return data;
        }
        //===============
        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                System.ServiceProcess.ServiceController c = new System.ServiceProcess.ServiceController("HFS-Service");
                System.ServiceProcess.ServiceControllerStatus status = c.Status;
                //if (status == System.ServiceProcess.ServiceControllerStatus.Stopped)
                if (status == System.ServiceProcess.ServiceControllerStatus.Running)
                {
                    //MessageBox.Show("HFS Service Started");
                    label_status.ForeColor = Color.Blue;
                    label_status.Text = "RUNNING";
                }
                else
                {
                    //MessageBox.Show("HFS Service Stoped");
                    label_status.ForeColor = Color.Blue;
                    label_status.Text = "STOPED";
                }
            }
            catch
            {
                //MessageBox.Show("HFS Service Not Instaled");
                //label_status.ForeColor = System.Drawing.Color.Red;
                label_status.ForeColor = Color.Red;
                label_status.Text = "SERVICE NOT INSTALLED";
            }
            
        }

        private void btbrowse_Click(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                string filename_only = System.IO.Path.GetFileName(openFileDialog1.FileName);
                hfsexe_path.Text = openFileDialog1.FileName;
                //hfsexe_path.Text = filename_only;
                //else
                //txtSource.Text = "";
            }
            else
            {
                //do nothing
            }

        }

        private void btcreate_Click(object sender, EventArgs e)
        {
            //salvar antes de criar
            string installscript_default = new EmbeddedResourceTextReader().GetFromResources("hfs2Service.hfs2s_engine.HFS-Service.ini");
            Save("HFS-Service.ini", installscript_default);
            //finda salvar aqui
            string service_name_readed = service_name.Text;
            //MessageBox.Show(service_name_readed);
            string hfsexe_path_readed = hfsexe_path.Text;
            //MessageBox.Show(hfsexe_path_readed);
            string num_updown_checks_readed = num_updown_checks.Value.ToString();
            //MessageBox.Show(num_updown_checks_readed);
            string num_updown_start_readed = num_updown_start.Value.ToString();
            //MessageBox.Show(num_updown_start_readed);
            string chkbox_restart_readed = chkbox_restart.Checked.ToString();
            //MessageBox.Show(chkbox_restart_readed);
            //hora do string builder teste....
            //string str = "ServiceName=_SERVICENAME_CheckProcessSeconds = _TIME2CHECKPROCESS_CommandLine = HFS_FULL_PATH.EXE_WorkingDir= _LOCAL_WORKING_DIR_PauseStart= _SEC2START000_PauseEnd= _SEC2END000_UserInterface = Yes_No1_Restart = Yes_No2";
            string str = Read("HFS-Service.ini");
            StringBuilder sb = new StringBuilder(str);
            Console.WriteLine("Original value:");
            sb.Replace("_SERVICENAME", service_name_readed);
            sb.Replace("_TIME2CHECKPROCESS", num_updown_checks_readed);
            sb.Replace("HFS_FULL_PATH", hfsexe_path_readed);
            sb.Replace("_LOCAL_WORKING_DIR", hfsexe_path_readed.Replace("hfs.exe", ""));
            sb.Replace("_SEC2START", num_updown_start_readed);
            sb.Replace("_SEC2END", "1");
            sb.Replace("Yes_No1", "Yes");
            if (chkbox_restart.Checked == true)
            {
                sb.Replace("Yes_No2", "Yes");
            }
            else
            {
                sb.Replace("Yes_No2", "No");
            }

            string sb_r = sb.ToString();
            //agora que foram substituidas na string, salvo novamente o arquivo
            string fullexe_path = Application.ExecutablePath;
            //MessageBox.Show(fullexe_path);
            string filename_only = System.IO.Path.GetFileName(fullexe_path);
            //MessageBox.Show(filename_only);
            string path_tosave_temps = fullexe_path.Replace(filename_only, "");
            Save(path_tosave_temps + "HFS-Service.ini", sb_r);
            //finda o save aqui
            MessageBox.Show(sb_r);
            //finda aqui o teste, e bem sucedido!!!
            Process.Start(path_tosave_temps + "HFS-Service.exe", "-i");
        }


        private void chkbox_restart_CheckedChanged(object sender, EventArgs e)
        {
            //MessageBox.Show("Status is: " + chkbox_restart.Checked.ToString());
        }

        private void hfs2service_Load(object sender, EventArgs e)
        {
            //aqui usarei o timer
            
            //fim do teste do timer
            //aqui o autosave do ini para ser lido e modificado
            try
            {
                string installscript_default = new EmbeddedResourceTextReader().GetFromResources("hfs2Service.hfs2s_engine.HFS-Service.ini");
                //string hfs2service_engine = new EmbeddedResourceTextReader().GetFromResources("hfs2Service.hfs2s_engine.HFS-Service.exe");
                //MessageBox.Show(installscript_default);
                //this.editor_main.Text = main_default;
                //string comment_readed = textBox1_comment.Text;
                //string full_path = openFileDialog1.FileName + ".comment";
                string fullexe_path = Application.ExecutablePath;
                //MessageBox.Show(fullexe_path);
                string filename_only = System.IO.Path.GetFileName(fullexe_path);
                //MessageBox.Show(filename_only);
                string path_tosave_temps = fullexe_path.Replace(filename_only, "");
                //MessageBox.Show(path_tosave_temps);
                Save(path_tosave_temps + "HFS-Service.ini", installscript_default);
                //Save(path_tosave_temps + "HFS-Service.exe", hfs2service_engine);
            }
            catch (Exception error)
            {
                MessageBox.Show(error.Message);
            }
            try
            {
                // Get Current Assembly refrence
                Assembly currentAssembly = Assembly.GetExecutingAssembly();
                // Get all imbedded resources
                string[] arrResources = currentAssembly.GetManifestResourceNames();

                foreach (string resourceName in arrResources)
                {
                    if (resourceName.EndsWith(".exe"))
                    { //or any other extension desired
                        //Name of the file saved on disk
                        string saveAsName = "HFS-Service.exe";
                        FileInfo fileInfoOutputFile = new FileInfo(saveAsName);

                        if (fileInfoOutputFile.Exists)
                        {
                            //overwrite if desired or break (depending on your needs)
                            //fileInfoOutputFile.Delete();
                        }
                        //OPEN NEWLY CREATING FILE FOR WRITTING
                        FileStream streamToOutputFile = fileInfoOutputFile.OpenWrite();
                        //GET THE STREAM TO THE RESOURCES
                        Stream streamToResourceFile = currentAssembly.GetManifestResourceStream(resourceName);

                        //---------------------------------
                        //SAVE TO DISK OPERATION
                        //---------------------------------
                        const int size = 4096;
                        byte[] bytes = new byte[4096];
                        int numBytes;
                        while ((numBytes = streamToResourceFile.Read(bytes, 0, size)) > 0)
                        {
                            streamToOutputFile.Write(bytes, 0, numBytes);
                        }

                        streamToOutputFile.Close();
                        streamToResourceFile.Close();
                    }//if

                }//end_foreach

                //finda aqui o save do exe
            }
            catch (Exception error)
            {
                MessageBox.Show(error.Message);
            }


            //agora defino o texto inicial do campo hfs.exe path, sugiro o mesmo diretrio que o hfs2service
            string exe_path = Application.ExecutablePath;
            string filename_app = System.IO.Path.GetFileName(exe_path);
            string caminhosugerido = exe_path.Replace(filename_app, "");
            string caminhosugerido_hfs = caminhosugerido + "hfs.exe";
            hfsexe_path.Text = caminhosugerido_hfs;
            //acaba a sugesto
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            //aqui usarei o timer on change
            try
            {
                System.ServiceProcess.ServiceController c = new System.ServiceProcess.ServiceController("HFS-Service");
                System.ServiceProcess.ServiceControllerStatus status = c.Status;
                //if (status == System.ServiceProcess.ServiceControllerStatus.Stopped)
                if (status == System.ServiceProcess.ServiceControllerStatus.Running)
                {
                    //MessageBox.Show("HFS Service Started");
                    label_status.ForeColor = Color.Blue;
                    label_status.Text = "RUNNING";
                }
                else
                {
                    //MessageBox.Show("HFS Service Stoped");
                    label_status.ForeColor = Color.Blue;
                    label_status.Text = "STOPED";
                }
            }
            catch
            {
                //MessageBox.Show("HFS Service Not Instaled");
                //label_status.ForeColor = System.Drawing.Color.Red;
                label_status.ForeColor = Color.Red;
                label_status.Text = "SERVICE NOT INSTALLED";
            }
            //fim do teste do timer on change
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void hfs2service_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                string fullexe_path = Application.ExecutablePath;
                string filename_only = System.IO.Path.GetFileName(fullexe_path);
                string path_tosave_temps = fullexe_path.Replace(filename_only, "");
                string file2delete = path_tosave_temps + "HFS-Service.ini";
                string hfs2service_engine = path_tosave_temps + "HFS-Service.exe";
                //File.Delete(file2delete);
                //File.Delete(hfs2service_engine);
            }
            catch (Exception error)
            {
                MessageBox.Show(error.Message);
            }
        }

        private void btstart_Click(object sender, EventArgs e)
        {
            string fullexe_path = Application.ExecutablePath;
            string filename_only = System.IO.Path.GetFileName(fullexe_path);
            string path_tosave_temps = fullexe_path.Replace(filename_only, "");
            Process.Start(path_tosave_temps + "HFS-Service.exe", "-r HFS-Service");
        }

        private void btstop_Click(object sender, EventArgs e)
        {
            string fullexe_path = Application.ExecutablePath;
            string filename_only = System.IO.Path.GetFileName(fullexe_path);
            string path_tosave_temps = fullexe_path.Replace(filename_only, "");
            Process.Start(path_tosave_temps + "HFS-Service.exe", "-k HFS-Service");
        }

        private void btremove_Click(object sender, EventArgs e)
        {
            string fullexe_path = Application.ExecutablePath;
            string filename_only = System.IO.Path.GetFileName(fullexe_path);
            string path_tosave_temps = fullexe_path.Replace(filename_only, "");
            Process.Start(path_tosave_temps + "HFS-Service.exe", "-u");
        }

        private void btrestart_Click(object sender, EventArgs e)
        {
            string fullexe_path = Application.ExecutablePath;
            string filename_only = System.IO.Path.GetFileName(fullexe_path);
            string path_tosave_temps = fullexe_path.Replace(filename_only, "");
            Process.Start(path_tosave_temps + "HFS-Service.exe", "-b HFS-Service");
        }
    }
}